
#ifndef INC_ACTION_H_
#define INC_ACTION_H_

#include "stm32l4xx_hal.h"
#include "stdint.h"
#include "command.h"

#define ACTION_FALSE	(0)
#define ACTION_TRUE	(1)

void action_init(ADC_HandleTypeDef *pAdcChA,			// ADC Ch.A <ADC1 IN2>
						   ADC_HandleTypeDef *pAdcChB,			// ADC Ch.B <ADC3 IN1>
						   ADC_HandleTypeDef *pMonitor,			// MONITOR Ch.A/ B/ C/ D <ADC2 IN5/ 6/ 11/ 12>
						   DMA_HandleTypeDef *pDmaAdcChA,	// DMA for ADC Ch.A <DMA1 CH1>
						   DMA_HandleTypeDef *pDmaAdcChB,	// DMA for ADC Ch.B <DMA2 CH5>
						   DMA_HandleTypeDef *pDmaAdcMonitor,  // DMA for MONITOR Ch.A/ B/ C/ D <DMA2 CH4>
						   COMP_HandleTypeDef *pComp,			// COMP <COMP2>
						   DAC_HandleTypeDef *pDacChA,			// DAC TRG, DAC Ch.A <DAC1 OUT2>
						   DMA_HandleTypeDef *pDmaDacChA,	// DMA for DAC Ch.A <DMA1 CH4>
						   OPAMP_HandleTypeDef *pOpamp,		// OPAMP <OPAMP2>
						   TIM_HandleTypeDef *pTimPwm, 			// PWM Timer <TIM2 CH3>
						   TIM_HandleTypeDef *pTimAdc,			// ADC Timer <TIM3>
						   TIM_HandleTypeDef *pTimMonitor,		// LOG Timer <TIM4>
						   TIM_HandleTypeDef *pTimDac,			// DAC Timer <TIM5>
						   UART_HandleTypeDef *pUart  				// UART <USART2>
						   );

uint8_t action_command(const CommandTypeDef *command_def);
void action_polling(void);

#endif /* INC_ACTION_H_ */
